/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package experSwingJfreeChart;

import org.jfree.data.xy.*;//needed for XYSeries, could have called directly
import org.jfree.chart.*;//needed for createXYLineChart
/**
 *
 * @author pchr
 */
public class Chart {
    private XYSeries series;
    private XYDataset dataset;
    private JFreeChart chart;
    
    // constructor
    public Chart(ESDOF theESDOF){
        series = new XYSeries("γραφική παράσταση");
        int n_points =theESDOF.getSdofOscillator().getFext().length;
        for (int i = 0;i< n_points;i++){
            //calculate the data to be plotted
            series.add(theESDOF.getSdofOscillator().getTime()[i],theESDOF.getSdofOscillator().getFext()[i]) ;//add the computed values to the series
        }
        dataset = new XYSeriesCollection(series);
        chart = ChartFactory.createXYLineChart(
                                            "Επιλεγμένο Διάγραμμα",
                                            theESDOF.getXparameter(),
                                            theESDOF.getYparameter(),
                                            dataset,
                                            org.jfree.chart.plot.PlotOrientation.VERTICAL,
                                            false,
                                            false,
                                            false
                                            );
    }
    
    
    // methods
    public JFreeChart getChart(){
        return this.chart;
    }
    
    public JFreeChart getChart(ESDOF theESDOF){
        series = new XYSeries("γραφική παράσταση");
        int n_points =theESDOF.getSdofOscillator().getNSteps();
        int x_ind=theESDOF.getXindex();
        int y_ind=theESDOF.getYindex();
        for (int i = 0;i< n_points;i++){
            //calculate the data to be plotted
            series.add(theESDOF.getSdofOscillator().getHistory(x_ind)[i],theESDOF.getSdofOscillator().getHistory(y_ind)[i]) ;//add the computed values to the series
        }
        dataset = new XYSeriesCollection(series);
        chart = ChartFactory.createXYLineChart(
                                            "Επιλεγμένο Διάγραμμα",
                                            theESDOF.getXparameter(),
                                            theESDOF.getYparameter(),
                                            dataset,
                                            org.jfree.chart.plot.PlotOrientation.VERTICAL,
                                            false,
                                            false,
                                            false
                                            );
        return this.chart;
    }

}
